package duggelz.jape;

import java.awt.Choice;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Vector;

// Referenced classes of package duggelz.jape:
//            DataChangeEvent, DataChangeMixin, FieldView, Structure, 
//            DataChangeListener

public class ChoiceView extends Choice
    implements FieldView, ItemListener
{

    public ChoiceView(String fieldName, Vector choices)
    {
        suppressEvents = false;
        modified = false;
        mixin = new DataChangeMixin();
        this.fieldName = fieldName;
        for(int idx = 0; idx < choices.size(); idx++)
            add((String)choices.elementAt(idx));

        addItemListener(this);
    }

    public void addDataChangeListener(DataChangeListener l)
    {
        mixin.addDataChangeListener(l);
    }

    public void commit(String newValue)
    {
        if(struct != null)
        {
            String oldValue = struct.get(fieldName);
            if(oldValue == null && newValue != null || oldValue != null && !oldValue.equals(newValue))
            {
                modified = true;
                struct.set(fieldName, newValue);
                fireDataChangeEvent(new DataChangeEvent(this, this.oldValue, newValue));
            }
        }
    }

    public void fireDataChangeEvent(DataChangeEvent e)
    {
        mixin.fireDataChangeEvent(e);
    }

    public String getFieldName()
    {
        return fieldName;
    }

    public String getValue()
    {
        return getSelectedItem();
    }

    public boolean isModified()
    {
        return modified;
    }

    public void itemStateChanged(ItemEvent event)
    {
        if(suppressEvents)
        {
            return;
        } else
        {
            String newValue = getSelectedItem();
            commit(newValue);
            oldValue = newValue;
            return;
        }
    }

    public synchronized void refresh()
    {
        try
        {
            suppressEvents = true;
            String value = null;
            if(struct != null)
                value = struct.get(fieldName);
            if(value != null)
                select(value);
            else
                select(0);
            oldValue = value;
            modified = false;
        }
        finally
        {
            suppressEvents = false;
        }
    }

    public void removeDataChangeListener(DataChangeListener l)
    {
        mixin.removeDataChangeListener(l);
    }

    public void setStruct(Structure struct)
    {
        this.struct = struct;
    }

    private boolean suppressEvents;
    private String fieldName;
    private boolean modified;
    private String oldValue;
    private Structure struct;
    private DataChangeMixin mixin;
}
