package duggelz.jape;

import java.util.Hashtable;

// Referenced classes of package duggelz.jape:
//            BasicStructure, ByteField, ChoiceField, ItemExemplar, 
//            ShortField

public class Item extends BasicStructure
{

    public Item(byte data[])
    {
        super(classFields);
        super.data = data;
    }

    public byte[] encode()
    {
        return super.data;
    }

    public ItemExemplar getExemplar()
    {
        int fieldValue = getInt("Item ID");
        ItemExemplar exemplar = (ItemExemplar)ItemExemplar.exemplarTable.get(new Integer(fieldValue));
        return exemplar;
    }

    public void set(String name, String value)
    {
        super.set(name, value);
    }

    public void setInt(String name, int value)
    {
        super.setInt(name, value);
    }

    public static final int ITEM_LENGTH = 36;
    public static final int ID_OFFSET = 0;
    public static final int QUANTITY_OFFSET = 2;
    public static final int ITEM_1_PERCENT_OFFSET = 4;
    public static final int ITEM_2_PERCENT_OFFSET = 5;
    public static final int ITEM_3_PERCENT_OFFSET = 6;
    public static final int ITEM_4_PERCENT_OFFSET = 7;
    public static final int ITEM_5_PERCENT_OFFSET = 8;
    public static final int ITEM_6_PERCENT_OFFSET = 9;
    public static final int MONEY_VALUE_OFFSET = 8;
    public static final int AMMO_VARIETY_OFFSET = 5;
    public static final int AMMO_QUANTITY_OFFSET = 6;
    public static final int AMMO_ID_OFFSET = 8;
    public static final int AMMO_PERCENT_OFFSET = 10;
    public static final int ATTACHMENT_1_ID_OFFSET = 16;
    public static final int ATTACHMENT_2_ID_OFFSET = 18;
    public static final int ATTACHMENT_3_ID_OFFSET = 20;
    public static final int ATTACHMENT_4_ID_OFFSET = 22;
    public static final int ATTACHMENT_1_PERCENT_OFFSET = 24;
    public static final int ATTACHMENT_2_PERCENT_OFFSET = 25;
    public static final int ATTACHMENT_3_PERCENT_OFFSET = 26;
    public static final int ATTACHMENT_4_PERCENT_OFFSET = 27;
    public static final int UNKNOWN_1_OFFSET = 28;
    public static final int UNKNOWN_2_OFFSET = 29;
    public static final int UNKNOWN_3_OFFSET = 30;
    public static final int UNKNOWN_4_OFFSET = 31;
    public static final int WEIGHT_OFFSET = 32;
    public static Hashtable classFields;

    static 
    {
        classFields = new Hashtable();
        classFields.put("Item ID", new ChoiceField(new ShortField(0), ItemExemplar.nameTable));
        classFields.put("Quantity", new ShortField(2));
        classFields.put("Item 1 %", new ByteField(4));
        classFields.put("Item 2 %", new ByteField(5));
        classFields.put("Item 3 %", new ByteField(6));
        classFields.put("Item 4 %", new ByteField(7));
        classFields.put("Item 5 %", new ByteField(8));
        classFields.put("Item 6 %", new ByteField(9));
        classFields.put("Money Value", new ShortField(8));
        classFields.put("Ammo Variety", new ByteField(5));
        classFields.put("Ammo Quantity", new ShortField(6));
        classFields.put("Ammo ID", new ChoiceField(new ShortField(8), ItemExemplar.nameTable));
        classFields.put("Ammo %", new ByteField(10));
        classFields.put("Attachment 1 ID", new ChoiceField(new ShortField(16), ItemExemplar.nameTable));
        classFields.put("Attachment 2 ID", new ChoiceField(new ShortField(18), ItemExemplar.nameTable));
        classFields.put("Attachment 3 ID", new ChoiceField(new ShortField(20), ItemExemplar.nameTable));
        classFields.put("Attachment 4 ID", new ChoiceField(new ShortField(22), ItemExemplar.nameTable));
        classFields.put("Attachment 1 %", new ByteField(24));
        classFields.put("Attachment 2 %", new ByteField(25));
        classFields.put("Attachment 3 %", new ByteField(26));
        classFields.put("Attachment 4 %", new ByteField(27));
        classFields.put("Unknown 1", new ByteField(28));
        classFields.put("Unknown 2", new ByteField(29));
        classFields.put("Unknown 3", new ByteField(30));
        classFields.put("Unknown 4", new ByteField(31));
        classFields.put("Weight", new ShortField(32));
    }
}
