package duggelz.jape;

import java.util.Hashtable;
import java.util.Vector;

class ItemExemplar
{

    public ItemExemplar(int id, String name, int category)
    {
        this(id, name, category, 0, 0, 0, 0);
    }

    public ItemExemplar(int id, String name, int category, int arg1)
    {
        this(id, name, category, arg1, 0, 0, 0);
    }

    public ItemExemplar(int id, String name, int category, int arg1, int arg2)
    {
        this(id, name, category, arg1, arg2, 0, 0);
    }

    public ItemExemplar(int id, String name, int category, int arg1, int arg2, int arg3)
    {
        this(id, name, category, arg1, arg2, arg3, 0);
    }

    public ItemExemplar(int id, String name, int category, int arg1, int arg2, int arg3, int arg4)
    {
        this.id = id;
        this.name = name;
        this.category = category;
        switch(this.category)
        {
        case 1: // '\001'
            ammo1 = arg1;
            ammo2 = arg2;
            ammo3 = arg3;
            ammo4 = arg4;
            break;

        case 4: // '\004'
            ammoVariety = arg1;
            ammoCapacity = arg2;
            ammoNameList.addElement(this.name);
            break;

        case 3: // '\003'
            attachmentNameList.addElement(this.name);
            break;

        case 10: // '\n'
            attachmentNameList.addElement(this.name);
            break;

        case 5: // '\005'
            attachmentNameList.addElement(this.name);
            break;

        case 7: // '\007'
            attachmentNameList.addElement(this.name);
            break;
        }
        nameTable.put(name, new Integer(id));
        nameTable.put(new Integer(id), name);
        exemplarTable.put(name, this);
        exemplarTable.put(new Integer(id), this);
        nameList.addElement(this.name);
    }

    public static final int NONE_CATEGORY = 0;
    public static final int WEAPON_CATEGORY = 1;
    public static final int MELEE_WEAPON_CATEGORY = 2;
    public static final int WEAPON_ATTACHMENT_CATEGORY = 3;
    public static final int AMMO_CATEGORY = 4;
    public static final int GRENADE_CATEGORY = 5;
    public static final int EXPLOSIVE_CATEGORY = 6;
    public static final int DETONATOR_CATEGORY = 7;
    public static final int HELMET_CATEGORY = 8;
    public static final int BODY_ARMOR_CATEGORY = 9;
    public static final int ARMOR_ATTACHMENT_CATEGORY = 10;
    public static final int LEG_ARMOR_CATEGORY = 11;
    public static final int HEAD_GEAR_CATEGORY = 12;
    public static final int MEDICAL_CATEGORY = 13;
    public static final int TOOL_CATEGORY = 14;
    public static final int USABLE_ITEM_CATEGORY = 15;
    public static final int MISC_CATEGORY = 16;
    public static final int KEY_CATEGORY = 17;
    public static final int MONEY_CATEGORY = 18;
    public static Hashtable nameTable = new Hashtable();
    public static Hashtable exemplarTable = new Hashtable();
    public static Vector nameList = new Vector();
    public static Vector ammoNameList;
    public static Vector attachmentNameList;
    public int id;
    public String name;
    public int category;
    public int ammo1;
    public int ammo2;
    public int ammo3;
    public int ammo4;
    public int ammoVariety;
    public int ammoCapacity;

    static 
    {
        ammoNameList = new Vector();
        attachmentNameList = new Vector();
        ammoNameList.addElement("None");
        attachmentNameList.addElement("None");
        new ItemExemplar(0, "None", 0);
        new ItemExemplar(1, "Glock 17", 1, 71, 73, 75);
        new ItemExemplar(2, "Glock 18", 1, 71, 73, 75);
        new ItemExemplar(3, "Beretta 92F", 1, 71, 73, 75);
        new ItemExemplar(4, "Beretta 92R", 1, 71, 73, 75);
        new ItemExemplar(5, ".38 Special", 1, 77, 78, 79);
        new ItemExemplar(6, "Barracuda", 1, 86, 88, 90);
        new ItemExemplar(7, "Desert Eagle", 1, 87, 89, 91);
        new ItemExemplar(8, "Colt .45", 1, 80, 82, 84);
        new ItemExemplar(9, "H&K MP5K", 1, 72, 74, 76);
        new ItemExemplar(10, "MAC-10", 1, 81, 83, 85);
        new ItemExemplar(11, "Thompson M1A1", 1, 81, 83, 85);
        new ItemExemplar(12, "Colt Commando", 1, 94, 95);
        new ItemExemplar(13, "H&K MP53", 1, 94, 95);
        new ItemExemplar(14, "AKSU-74", 1, 92, 93);
        new ItemExemplar(15, "FN-P90", 1, 105, 106);
        new ItemExemplar(16, "Type-85", 1, 96, 98);
        new ItemExemplar(17, "SKS", 1, 96, 98);
        new ItemExemplar(18, "Dragunov", 1, 96, 98);
        new ItemExemplar(19, "M24", 1, 100, 102);
        new ItemExemplar(20, "Steyr AUG", 1, 94, 95);
        new ItemExemplar(21, "H&K G41", 1, 94, 95);
        new ItemExemplar(22, "Ruger Mini-14", 1, 94, 95);
        new ItemExemplar(23, "C-7", 1, 94, 95);
        new ItemExemplar(24, "FA-MAS", 1, 94, 95);
        new ItemExemplar(25, "AK-74", 1, 92, 93);
        new ItemExemplar(26, "AKM", 1, 97, 99);
        new ItemExemplar(27, "M14", 1, 101, 103);
        new ItemExemplar(28, "FN-FAL", 1, 101, 103);
        new ItemExemplar(29, "H&K G3A3", 1, 101, 103);
        new ItemExemplar(30, "H&K G11", 1, 104);
        new ItemExemplar(31, "Remington M870", 1, 107, 108);
        new ItemExemplar(32, "SPAS-15", 1, 107, 108);
        new ItemExemplar(33, "CAWS", 1, 109, 110);
        new ItemExemplar(34, "FN Minimi", 1, 94, 95);
        new ItemExemplar(35, "RPK-74", 1, 92, 93);
        new ItemExemplar(36, "H&K 21", 1, 101, 103);
        new ItemExemplar(37, "Combat Knife", 2);
        new ItemExemplar(38, "Throwing Knife", 2);
        new ItemExemplar(39, "A Rock", 2);
        new ItemExemplar(40, "Grenade Launcher", 1, 147, 148, 149, 150);
        new ItemExemplar(41, "Mortar", 1, 140);
        new ItemExemplar(42, "Another Rock", 2);
        new ItemExemplar(43, "Young Male Creature Claws", 2);
        new ItemExemplar(44, "Young Female Creature Claws", 2);
        new ItemExemplar(45, "Adult Male Creature Claws", 2);
        new ItemExemplar(46, "Adult Female Creature Claws", 2);
        new ItemExemplar(47, "Queen Tentacle", 2);
        new ItemExemplar(48, "Queen Creature Spit", 2);
        new ItemExemplar(49, "Knuckle Dusters", 2);
        new ItemExemplar(50, "Underslung Grenade Launcher", 3);
        new ItemExemplar(51, "LAW", 1);
        new ItemExemplar(52, "Bloodcat Claws", 2);
        new ItemExemplar(53, "Bloodcat Bite", 2);
        new ItemExemplar(54, "Machete", 2);
        new ItemExemplar(55, "Rocket Rifle", 1, 111, 112, 113);
        new ItemExemplar(56, "Automag III", 1, 100, 102);
        new ItemExemplar(57, "Infant Creature Spit", 2);
        new ItemExemplar(58, "Young Male Spit", 2);
        new ItemExemplar(59, "Old Male Spit", 2);
        new ItemExemplar(60, "Tank Cannon", 1);
        new ItemExemplar(61, "Dart Gun", 1, 114);
        new ItemExemplar(62, "Bloody Throwing Knife", 2);
        new ItemExemplar(63, "Flamethrower", 1);
        new ItemExemplar(64, "Crowbar", 15);
        new ItemExemplar(65, "Auto Rocket Rifle", 1, 111, 112, 113);
        new ItemExemplar(71, "9mm Pistol Magazine", 4, 0, 15);
        new ItemExemplar(72, "9mm SMG Magazine", 4, 0, 30);
        new ItemExemplar(73, "9mm Pistol Magazine, AP", 4, 2, 15);
        new ItemExemplar(74, "9mm SMG Magazine, AP", 4, 2, 30);
        new ItemExemplar(75, "9mm Pistol Magazine, HP", 4, 1, 15);
        new ItemExemplar(76, "9mm SMG Magazine, HP", 4, 1, 30);
        new ItemExemplar(77, ".38 Speed Loader", 4, 0, 6);
        new ItemExemplar(78, ".38 Speed Loader, AP", 4, 2, 6);
        new ItemExemplar(79, ".38 Speed Loader, HP", 4, 1, 6);
        new ItemExemplar(80, ".45 Pistol Magazine", 4, 0, 7);
        new ItemExemplar(81, ".45 SMG Magazine", 4, 0, 30);
        new ItemExemplar(82, ".45 Pistol Magazine, AP", 4, 2, 7);
        new ItemExemplar(83, ".45 SMG Magazine, AP", 4, 2, 30);
        new ItemExemplar(84, ".45 Pistol Magazine, HP", 4, 1, 7);
        new ItemExemplar(85, ".45 SMG Magazine, HP", 4, 1, 30);
        new ItemExemplar(86, ".357 Speed Loader", 4, 0, 6);
        new ItemExemplar(87, ".357 Magazine", 4, 0, 9);
        new ItemExemplar(88, ".357 Speed Loader, AP", 4, 2, 6);
        new ItemExemplar(89, ".357 Magazine, AP", 4, 2, 9);
        new ItemExemplar(90, ".357 Speed Loader, HP", 4, 1, 6);
        new ItemExemplar(91, ".357 Magazine, HP", 4, 1, 9);
        new ItemExemplar(92, "5.45mm Magazine", 4, 2, 30);
        new ItemExemplar(93, "5.45mm Magazine, HP", 4, 1, 30);
        new ItemExemplar(94, "5.56mm Magazine", 4, 2, 30);
        new ItemExemplar(95, "5.56mm Magazine, HP", 4, 1, 30);
        new ItemExemplar(96, "7.62mm WP Magazine, 10", 4, 2, 10);
        new ItemExemplar(97, "7.62mm WP Magazine, 30", 4, 2, 30);
        new ItemExemplar(98, "7.62mm WP Magazine, 10 HP", 4, 1, 10);
        new ItemExemplar(99, "7.62mm WP Magazine, 30 HP", 4, 1, 30);
        new ItemExemplar(100, "7.62mm NATO Magazine, 5", 4, 2, 5);
        new ItemExemplar(101, "7.62mm NATO Magazine, 20", 4, 2, 20);
        new ItemExemplar(102, "7.62mm NATO Ammunition, 5 HP", 4, 1, 5);
        new ItemExemplar(103, "7.62mm NATO Magazine, 20 HP", 4, 1, 20);
        new ItemExemplar(104, "4.7mm Magazine", 4, 2, 50);
        new ItemExemplar(105, "5.7mm Magazine", 4, 2, 50);
        new ItemExemplar(106, "5.7mm Magazine, HP", 4, 1, 50);
        new ItemExemplar(107, "12 Gauge Magazine", 4, 3, 7);
        new ItemExemplar(108, "12 Gauge Magazine, Buckshot", 4, 4, 7);
        new ItemExemplar(109, "CAWS Magazine", 4, 3, 10);
        new ItemExemplar(110, "CAWS Magazine, Buckshot", 4, 4, 10);
        new ItemExemplar(111, "Minirockets, AP", 4, 9, 5);
        new ItemExemplar(112, "Minirockets, HP", 4, 8, 5);
        new ItemExemplar(113, "Minirockets, HEAP", 4, 10, 5);
        new ItemExemplar(114, "Tranquilizer Dart", 4, 11, 1);
        new ItemExemplar(131, "Stun Grenade", 5);
        new ItemExemplar(132, "Tear Gas Grenade", 5);
        new ItemExemplar(133, "Mustard Gas Grenade", 5);
        new ItemExemplar(134, "Mini Hand Grenade", 5);
        new ItemExemplar(135, "Reg Hand Grenade", 5);
        new ItemExemplar(136, "A Jar of RDX Crystals", 6);
        new ItemExemplar(137, "TNT", 6);
        new ItemExemplar(138, "HMX", 6);
        new ItemExemplar(139, "C1", 6);
        new ItemExemplar(140, "Mortar Shell", 5);
        new ItemExemplar(141, "Land Mine", 6);
        new ItemExemplar(142, "C4", 6);
        new ItemExemplar(143, "Trip Flare", 6);
        new ItemExemplar(144, "Trip Klaxon", 6);
        new ItemExemplar(145, "Shaped Charge", 6);
        new ItemExemplar(146, "Chemical Break Light", 5);
        new ItemExemplar(147, "40mm Grenade", 5);
        new ItemExemplar(148, "40mm Tear Gas Grenade", 5);
        new ItemExemplar(149, "40mm Stun Grenade", 5);
        new ItemExemplar(150, "40mm Smoke Grenade", 5);
        new ItemExemplar(151, "Smoke Grenade", 5);
        new ItemExemplar(152, "Tank Shell", 5);
        new ItemExemplar(153, "Struct Ignite", 6);
        new ItemExemplar(154, "Creature Cocktail", 5);
        new ItemExemplar(155, "Structure Explosion", 6);
        new ItemExemplar(156, "Great Big Explosion", 6);
        new ItemExemplar(157, "Big Tear Gas", 5);
        new ItemExemplar(158, "Small Creature Gas", 6);
        new ItemExemplar(159, "Large Creature Gas", 6);
        new ItemExemplar(161, "Flak Jacket", 9);
        new ItemExemplar(162, "Compound 18 Flak Jacket", 9);
        new ItemExemplar(163, "Coated Flak Jacket", 9);
        new ItemExemplar(164, "Kevlar Vest", 9);
        new ItemExemplar(165, "Compound 18 Kevlar Vest", 9);
        new ItemExemplar(166, "Coated Kevlar Vest", 9);
        new ItemExemplar(167, "Spectra Vest", 9);
        new ItemExemplar(168, "Compound 18 Spectra Vest", 9);
        new ItemExemplar(169, "Coated Spectra Vest", 9);
        new ItemExemplar(170, "Kevlar Leggings", 11);
        new ItemExemplar(171, "Compound 18 Kevlar Leggings", 11);
        new ItemExemplar(172, "Coated Kevlar Leggings", 11);
        new ItemExemplar(173, "Spectra Leggings", 11);
        new ItemExemplar(174, "Compound 18 Spectra Leggings", 11);
        new ItemExemplar(175, "Coated Spectra Leggings", 11);
        new ItemExemplar(176, "Steel Helmet", 8);
        new ItemExemplar(177, "Kevlar Helmet", 8);
        new ItemExemplar(178, "Compound 18 Kevlar Helmet", 8);
        new ItemExemplar(179, "Coated Kevlar Helmet", 8);
        new ItemExemplar(180, "Spectra Helmet", 8);
        new ItemExemplar(181, "Compound 18 Spectra Helmet", 8);
        new ItemExemplar(182, "Coated Spectra Helmet", 8);
        new ItemExemplar(183, "Ceramic Plates", 10);
        new ItemExemplar(184, "Infant Creature Hide", 9);
        new ItemExemplar(185, "Young Adult Creature Hide", 9);
        new ItemExemplar(186, "Adult Creature Hide", 9);
        new ItemExemplar(187, "Queen Creature Hide", 9);
        new ItemExemplar(188, "Leather Jacket", 9);
        new ItemExemplar(189, "Leather & Kevlar Jacket", 9);
        new ItemExemplar(190, "Compound 18 Leather & Kevlar Jacket", 9);
        new ItemExemplar(191, "Coated Leather & Kevlar Jacket", 9);
        new ItemExemplar(192, "Young Female Hide", 9);
        new ItemExemplar(193, "Old Female Hide", 9);
        new ItemExemplar(194, "Arulco T-Shirt", 9);
        new ItemExemplar(195, "Deidranna T-Shirt", 9);
        new ItemExemplar(196, "Guardian Vest", 9);
        new ItemExemplar(197, "Treated Guardian Vest", 9);
        new ItemExemplar(198, "Coated Guardian Vest", 9);
        new ItemExemplar(201, "First Aid Kit", 13);
        new ItemExemplar(202, "Medical Kit", 13);
        new ItemExemplar(203, "Tool Kit", 14);
        new ItemExemplar(204, "Locksmith Kit", 14);
        new ItemExemplar(205, "Camouflage Kit", 15);
        new ItemExemplar(206, "Boobytrap Kit", 15);
        new ItemExemplar(207, "Silencer", 3);
        new ItemExemplar(208, "Sniper Scope", 3);
        new ItemExemplar(209, "Bipod", 3);
        new ItemExemplar(210, "Extended Ear", 12);
        new ItemExemplar(211, "Night Vision Goggles", 12);
        new ItemExemplar(212, "Sun Goggles", 12);
        new ItemExemplar(213, "Gas Mask", 12);
        new ItemExemplar(214, "Canteen", 15);
        new ItemExemplar(215, "Metal Detector", 15);
        new ItemExemplar(216, "Compound 18", 15);
        new ItemExemplar(217, "Royal Jelly", 15);
        new ItemExemplar(218, "Jar of Elixir", 14);
        new ItemExemplar(219, "Money", 18);
        new ItemExemplar(220, "Glass Jar", 16);
        new ItemExemplar(221, "Jar of Blood", 16);
        new ItemExemplar(222, "Energy Booster", 13);
        new ItemExemplar(223, "Detonator", 7);
        new ItemExemplar(224, "Remote Detonator", 7);
        new ItemExemplar(225, "Videotape", 16);
        new ItemExemplar(226, "Deed", 16);
        new ItemExemplar(227, "Letter from Enrico", 16);
        new ItemExemplar(228, "Computer Diskette", 16);
        new ItemExemplar(229, "Chalice of Chance", 16);
        new ItemExemplar(230, "Bloodcat Claws", 16);
        new ItemExemplar(231, "Bloodcat Teeth", 16);
        new ItemExemplar(232, "Bloodcat Pelt", 16);
        new ItemExemplar(233, "Switch", 16);
        new ItemExemplar(234, "Action Item", 16);
        new ItemExemplar(235, "Regeneration Booster", 13);
        new ItemExemplar(236, "Syringe", 13);
        new ItemExemplar(237, "Syringe", 13);
        new ItemExemplar(238, "Syringe", 13);
        new ItemExemplar(239, "Jar of Human Blood", 16);
        new ItemExemplar(240, "Ownership", 16);
        new ItemExemplar(241, "Laser Scope", 3);
        new ItemExemplar(242, "Remote Bomb Trigger", 7);
        new ItemExemplar(243, "Wire Cutter", 14);
        new ItemExemplar(244, "Duckbill", 3);
        new ItemExemplar(245, "Bottle of Alcohol", 15);
        new ItemExemplar(246, "UV Goggles", 12);
        new ItemExemplar(248, "Head", 16);
        new ItemExemplar(249, "Imposter's Head", 16);
        new ItemExemplar(250, "T-Rex's Head", 16);
        new ItemExemplar(251, "Slay's Head", 16);
        new ItemExemplar(252, "Druggist's Head", 16);
        new ItemExemplar(253, "Matron's Head", 16);
        new ItemExemplar(254, "Tiffany's Head", 16);
        new ItemExemplar(255, "Wine", 15);
        new ItemExemplar(256, "Beer", 15);
        new ItemExemplar(257, "Porno Magazine", 16);
        new ItemExemplar(258, "Video Camera", 16);
        new ItemExemplar(259, "Robot Remote Control", 12);
        new ItemExemplar(260, "Creature Claw", 16);
        new ItemExemplar(261, "Creature Flesh", 16);
        new ItemExemplar(262, "Unidentifiable Creature Organ", 16);
        new ItemExemplar(263, "Remote Control", 16);
        new ItemExemplar(264, "Platinum Watch", 16);
        new ItemExemplar(265, "Golf Clubs", 16);
        new ItemExemplar(266, "Walkman", 16);
        new ItemExemplar(267, "Portable TV", 16);
        new ItemExemplar(268, "Current Balance:", 16);
        new ItemExemplar(269, "Cigars", 16);
        new ItemExemplar(271, "Small key", 17);
        new ItemExemplar(272, "Prison key", 17);
        new ItemExemplar(273, "Cheap key", 17);
        new ItemExemplar(274, "Dull key", 17);
        new ItemExemplar(275, "Shiny key", 17);
        new ItemExemplar(276, "Padlock key", 17);
        new ItemExemplar(277, "Electronic Key", 17);
        new ItemExemplar(278, "Keycard", 17);
        new ItemExemplar(279, "Key", 17);
        new ItemExemplar(280, "Key", 17);
        new ItemExemplar(281, "Key", 17);
        new ItemExemplar(282, "Key", 17);
        new ItemExemplar(283, "Key", 17);
        new ItemExemplar(284, "Key", 17);
        new ItemExemplar(285, "Key", 17);
        new ItemExemplar(286, "Key", 17);
        new ItemExemplar(287, "Key", 17);
        new ItemExemplar(288, "Key", 17);
        new ItemExemplar(289, "Key", 17);
        new ItemExemplar(290, "Key", 17);
        new ItemExemplar(291, "Key", 17);
        new ItemExemplar(292, "Key", 17);
        new ItemExemplar(293, "Key", 17);
        new ItemExemplar(294, "Key", 17);
        new ItemExemplar(295, "Key", 17);
        new ItemExemplar(296, "Key", 17);
        new ItemExemplar(297, "Key", 17);
        new ItemExemplar(298, "Key", 17);
        new ItemExemplar(299, "Key", 17);
        new ItemExemplar(300, "Key", 17);
        new ItemExemplar(301, "Key", 17);
        new ItemExemplar(302, "Key", 17);
        new ItemExemplar(303, "Silver Platter", 16);
        new ItemExemplar(304, "Duct Tape", 16);
        new ItemExemplar(305, "Aluminium Rod", 16);
        new ItemExemplar(306, "Spring", 16);
        new ItemExemplar(307, "Rod & Spring", 3);
        new ItemExemplar(308, "Steel Tube", 16);
        new ItemExemplar(309, "Quick Glue", 16);
        new ItemExemplar(310, "Gun Barrel Extender", 3);
        new ItemExemplar(311, "String", 16);
        new ItemExemplar(312, "Soda Can", 16);
        new ItemExemplar(313, "Soda Can with String", 15);
        new ItemExemplar(314, "Marbles", 15);
        new ItemExemplar(315, "LameBoy Display", 16);
        new ItemExemplar(316, "Copper Wire", 16);
        new ItemExemplar(317, "Display Unit", 16);
        new ItemExemplar(318, "FumblePak", 16);
        new ItemExemplar(319, "X-ray Tube", 16);
        new ItemExemplar(320, "Pack of Gum", 16);
        new ItemExemplar(321, "X-ray Device", 16);
        new ItemExemplar(322, "Batteries", 15);
        new ItemExemplar(323, "Rubber Band", 16);
        new ItemExemplar(324, "X-ray Detector", 15);
        new ItemExemplar(325, "Silver Nugget", 18);
        new ItemExemplar(326, "Gold Nugget", 18);
        new ItemExemplar(327, "Tank of Gas", 15);
    }
}
